<?php

/**
 * PAYONE Magento 2 Connector is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * PAYONE Magento 2 Connector is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with PAYONE Magento 2 Connector. If not, see <http://www.gnu.org/licenses/>.
 *
 * PHP version 5
 *
 * @category  Payone
 * @package   Payone_Magento2_Plugin
 * @author    FATCHIP GmbH <support@fatchip.de>
 * @copyright 2003 - 2017 Payone GmbH
 * @license   <http://www.gnu.org/licenses/> GNU Lesser General Public License
 * @link      http://www.payone.de
 */

namespace Payone\Core\Test\Unit\Block\Adminhtml\Order\View\Tab;

use Payone\Core\Block\Adminhtml\Order\View\Tab\TransactionStatus as ClassToTest;
use Magento\Framework\TestFramework\Unit\Helper\ObjectManager;

class TransactionStatusTest extends \PHPUnit_Framework_TestCase
{
    /**
     * @var ClassToTest
     */
    private $classToTest;

    /**
     * @var ObjectManager
     */
    private $objectManager;

    protected function setUp()
    {
        $this->objectManager = new ObjectManager($this);

        $this->classToTest = $this->objectManager->getObject(ClassToTest::class);
    }

    public function testGetTabLabel()
    {
        $result = $this->classToTest->getTabLabel();
        $expected = 'PAYONE Protokoll - Status';
        $this->assertEquals($expected, $result);
    }

    public function testGetTabTitle()
    {
        $result = $this->classToTest->getTabTitle();
        $expected = 'PAYONE Protokoll - Status';
        $this->assertEquals($expected, $result);
    }

    public function testCanShowTab()
    {
        $result = $this->classToTest->canShowTab();
        $this->assertTrue($result);
    }

    public function testIsHidden()
    {
        $result = $this->classToTest->isHidden();
        $this->assertFalse($result);
    }
}
